﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;
using System.Threading;

namespace Chat.Web
{
    public class UserUpdate
    {
        public string UserName{get;set;}
        public DateTime LatestTime{get;set;}
    }
    
    public class ChatService : IChatService
    {
        IChatServiceCallBack callBack;
        
        Timer timer;
        string _user;
        string _partner;
        public static List<UserUpdate> listUserUpdate = new List<UserUpdate>();
        public static List<MessageInfo> listMessages = new List<MessageInfo>();
        public static List<UserVideo> listVideos = new List<UserVideo>();
        public void StartTimer()
        {
            timer = new Timer(new TimerCallback(CallClientToReceiveMsg), null, 500, 500);
        }
        public bool Login(string user,string partner)
        {
            try
            {
                _user = user;
                _partner = partner;
                if (listUserUpdate.Where(m => m.UserName == user).ToList().Count == 0)
                {
                    listUserUpdate.Add(new UserUpdate() { UserName = user, LatestTime = DateTime.Now });
                }
                callBack = OperationContext.Current.GetCallbackChannel<IChatServiceCallBack>();
                StartTimer();
                return true;
            }
            catch 
            {
                return false;
            }
        }
        private void CallClientToReceiveMsg(object o)
        {
            try 
            { 
                DateTime dt = listUserUpdate.Where(m => m.UserName == _user).ToList()[0].LatestTime;
                listUserUpdate.Remove(listUserUpdate.Where(m => m.UserName == _user).ToList()[0]);
                listUserUpdate.Add(new UserUpdate() { UserName = _user, LatestTime = DateTime.Now });
                callBack.Receive(listMessages.Where(m => (m.Sender == _user && m.ReceiveUser == _partner && m.SendTime > dt) || (m.ReceiveUser == _user && m.Sender == _partner && m.SendTime > dt)).ToList());
                
            }
            catch
            {
                timer.Dispose(); 
                StartTimer();
            }
        }
        public bool SendMessage(MessageInfo message)
        {
            try
            {
                listMessages.Add(message);
                return true;
            }
            catch 
            {
                return false;
            }
        }

        public List<UserVideo> GetVideosByte(string userName,string partnerName)
        {
            List<UserVideo> list = new List<UserVideo>();
            list=listVideos.Where(m=>(m.UserName==partnerName&&m.PartnerName==userName)).ToList();
            if (list.Count > 0)
            {
                listVideos.RemoveAll(m => (m.UserName == partnerName && m.PartnerName == userName)); 
            }            
            return list;
        }

        public void SendVideoByte(UserVideo video)
        {
            listVideos.Add(video);
        }
    }
}
