﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.ServiceModel;
using System.Text;

namespace Chat.Web
{
    [ServiceContract(CallbackContract=typeof(IChatServiceCallBack))]
    public interface IChatService
    {
        [OperationContract]
        bool Login(string user,string partner);

        [OperationContract]
        bool SendMessage(MessageInfo message);

        [OperationContract]
        List<UserVideo> GetVideosByte(string userName, string partnerName);

        [OperationContract]
        void SendVideoByte(UserVideo video);
    }
         

    [ServiceContract]
    public interface IChatServiceCallBack
    {
        [OperationContract(IsOneWay=true)]
        void Receive(List<MessageInfo> messages);
    }
}
